seo:
  title: 共同開発プログラム：ユーザーとともに築くGitLab
  description: >-
    Thales、Scania、Kitwareなどの組織がどのようにGitLabのエンジニアと連携し、コミュニティ全体に利益をもたらす重要な機能の開発にコントリビュートしているかをご紹介します。
  ogTitle: 共同開発プログラム：ユーザーとともに築くGitLab
  ogDescription: >-
    Thales、Scania、Kitwareなどの組織がどのようにGitLabのエンジニアと連携し、コミュニティ全体に利益をもたらす重要な機能の開発にコントリビュートしているかをご紹介します。
  noIndex: false
  ogImage: images/blog/hero-images/REFERENCE---display-preview-for-blog-images.png
  ogUrl: >-
    https://about.gitlab.com/blog/the-co-create-program-how-customers-are-collaborating-to-build-gitlab
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: >-
    https://about.gitlab.com/blog/the-co-create-program-how-customers-are-collaborating-to-build-gitlab
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "共同開発プログラム：ユーザーとともに築くGitLab",
            "author": [{"@type":"Person","name":"Fatima Sarah Khalid"}],
            "datePublished": "2025-01-30",
          }

content:
  title: 共同開発プログラム：ユーザーとともに築くGitLab
  description: >-
    Thales、Scania、Kitwareなどの組織がどのようにGitLabのエンジニアと連携し、コミュニティ全体に利益をもたらす重要な機能の開発にコントリビュートしているかをご紹介します。
  authors:
    - Fatima Sarah Khalid
  heroImage: images/blog/hero-images/REFERENCE---display-preview-for-blog-images.png
  date: '2025-01-30'
  body: >
    過去一年間で、800人以上のコミュニティメンバーによって、GitLabに3,000回以上のコントリビュートが寄せられました。ThalesやScaniaなどの世界的な企業のチームメンバーも、GitLabの[共同開発プログラム](https://about.gitlab.com/community/co-create/)を通じてGitLabの進化にコントリビュートしています。このプログラムでは、GitLabユーザーがGitLabのエンジニアと直接協力し、プラットフォームに価値ある機能を提供しています。


    ワークショップやペアプログラミング、継続的なサポートを通じて、参加者はGitLabのアーキテクチャやコードベースに触れながら、機能改善や問題解決に取り組みます。


    「共同開発プログラムを通じた経験は本当に素晴らしいものでした」と、ThalesのオープンソースアドボケートであるSébastien
    Lejeune氏は述べています。「GitLabのコントリビューターサクセスチームのエンジニアと話し合いを始めてから、GitLabのリリースに反映されるまでわずか2か月でした」。


    この記事では、GitLabユーザーが共同開発プログラムを通じて、どのようにアイデアをコードとして実装し、学びながらコントリビュートしているのかをご紹介します。


    ## 共同開発プログラムについて

    [GitLab開発キット（GDK）](https://gitlab.com/gitlab-org/gitlab-development-kit)は、コントリビューターがGitLabではじめて開発を行う際に役立ちます。「新しいコントリビューターにアドバイスするとしたら、GDKで何かを壊すことはできないということです」とHook氏は言います。「変更を加えてうまくいかない場合は、元に戻したり、最初からやり直したりすることができます。GDKの良さは、環境を気にすることなく、調整したり、テストしたり、学んだりできることです」。


    共同開発プログラムに参加する各組織は、コントリビュートのプロセス全体を通じてサポートを受けられます。


    - __テクニカルオンボーディングワークショップ__：GitLab Development
    Kit（GDK）のセットアップやGitLabのアーキテクチャを理解するための専用セッション

    - __1対1のエンジニアリングサポート__：GitLabエンジニアとのペアプログラミングや技術的なアドバイス

    - __アーキテクチャの詳細解説__：各組織がコントリビュートしている課題に関連する特定のGitLabコンポーネントに焦点を当てたセッション

    - __コードレビューのサポート__：マージリクエストの手順に関する詳細なフィードバックとガイダンス

    - __定期的なチェックイン__：進捗状況を確認し、あらゆる課題に対処するための継続的なコラボレーション


    この仕組みにより、GitLabのコードベースやRuby/Goプログラミング言語になじみのないチームでも、効果的にコントリビュートできるようになります。KitwareのJohn
    Parent氏は次のように語ります。「GitLabを見たことも、使ったこともない人は、複数のプロジェクトにまたがる洗練されたアーキテクチャと膨大なコードを見て圧倒されるかもしれません。共同開発プログラムでは、社内研修で何週間もかけて学ぶ内容を、的を絞った短期集中コースとして学ぶことができます」。


    このプログラムの成果は、新機能の提供にとどまりません。GitLabとそのユーザーコミュニティの間に、長期的な関係を築くことにもつながっています。GitLabのプリンシパルエンジニアであるShekhar
    Patnaikは、「情熱を持ってGitLabの開発にコントリビュートしてくださるユーザーのみなさまを見て、私たちエンジニアも刺激をもらっています」と述べています。「ユーザーは『GitLab流』を学び、エンジニアはユーザーがGitLabの未来を形作る姿勢を目の当たりにするのです」。


    ## ThalesによるプロジェクトUXの向上

    Thalesは、GitLabの空のプロジェクトUIを改善できることに気づいた際、単に機能リクエストを提出するだけでなく、独自のソリューションを構築しました。同チームのコントリビュートの焦点は、インターフェイスをタブ形式にしてSSH/HTTPS設定を簡素化し、コードスニペットのコピー/ペースト機能を追加することで、新しいプロジェクトのセットアップを効率化することでした。これらの変更は、デベロッパーのワークフローに大きな影響を与えました。


    このチームの影響は、UXの改善だけにとどまりませんでした。Thalesでエッジクラウドアプリケーションの博士研究員を務めるQuentin
    Michaud氏は、GitLab Development Kit（GDK）の改善にもコントリビュートしました。Arch
    LinuxのパッケージメンテナーでもあるMichaud氏の専門知識により、GDKのドキュメントが改善され、コンテナ化の取り組みが進められたことで、今後のコントリビューターがより簡単に開発を始められるようになりました。


    「オープンソースの経験があったおかげで、Linuxディストリビューション向けのGDKサポートを改善する際に役立ちました」とMichaud氏は語ります。「パッケージのバージョン管理ドキュメントを改善する過程で、GitLabのコントリビューターサクセスチームもGDKのコンテナ化に取り組んでいることを知りました。双方の取り組みが交わる瞬間を見ることができて、非常に印象的でした。オープンソースのコラボレーションがより優れたソリューションを生み出すことを実感しました」。


    Thalesチームにとってポジティブな経験であったため、Lejeune氏は現在、共同開発を「オープンソースコントリビュートによる投資対効果をマネージャーに示す強力な事例」として使用しています。


    ## Scaniaと進めるパッケージサポート

    GitLabの高度なパッケージサポートが必要になったScaniaは、自らコントリビュートして、それを構築する機会を見出しました。


    「私たちは長年GitLabを使用し、組織内でオープンソースを積極的に推進してきました。共同開発プログラムのおかげで、オープンソースに直接コントリビュートする有意義なアプローチが可能になりました」とScaniaのソリューションアーキテクトであるPuttaraju
    Venugopal Hassan氏は語ります。


    チームはまず、コードベースとレビューのプロセスに慣れるために小さな変更から着手し、徐々に大きな機能開発へと進みました。「共同開発プログラムの最もやりがいのある点の一つは、プロセス全体を振り返り、自分たちがどれほど成長したかを実感できることです」とScaniaのソフトウェアデベロッパーであるOcéane
    Legrand氏は振り返ります。「最初は調査や小さな変更から取り組み、次第により大きなタスクへとステップアップしていきました。その進歩を目の当たりにできてうれしいです」。


    Scaniaのコントリビュートには、パッケージレジストリのバグ修正や、Conanパッケージレジストリ機能の強化が含まれます。これにより、Conanパッケージレジストリは一般公開（GA）に向けた準備が進み、Conanバージョン2のサポートが実装されました。Scaniaの取り組みとGitLabとのコラボレーションは、共同開発プログラムがGitLabのパッケージレジストリ機能の大幅な改善を促進できることを示しています。


    「共同開発プログラムを開始してすぐに、非常に体系的に構築されていることを実感しました。コントリビュートに必要なことをすべて学べるトレーニングセッションがありましたし、GitLabのエンジニアとの1対1のセッションでは、GitLabのパッケージアーキテクチャについて深く理解することができ、コントリビュートをスムーズに進められました」とScaniaのソフトウェアデベロッパーであるJuan
    Pablo Gonzalez氏は語ります。


    このプログラムの成果はコードのみにとどまりません。プログラム参加者は、コントリビュートを通じて貴重なスキルを身につけます。[GitLab
    17.8リリース](https://about.gitlab.com/releases/2025/01/16/gitlab-17-8-released/#mvp)では、Legrand氏とGonzalez氏がともにGitLab
    MVPに選ばれました。Legrand氏は、オープンソースでの作業がGitLabとScaniaの両方に与える影響について言及し、自身とチームの新たなスキル習得にもつながったと述べています。「共同開発プログラムを通じてコントリビュートすることで、Rubyやバックグラウンドマイグレーションの知識など、新たなスキルを習得できました。Scaniaで自分が所属するチームでアップグレード作業中に問題が発生した際、共同開発プログラムですでに同じ問題を経験していたため、トラブルシューティングを手伝うことができました」。##
    Kitwareによる高性能コンピューティング向け認証の最適化

    Kitwareは、国立研究所との協力で培った専門知識を活かし、GitLabの認証フレームワークの改善にコントリビュートしました。このコントリビュートには、GitLabのOAuth2デバイス認証付与フローのサポートの追加や、新しいデータベーステーブル、コントローラー、ビュー、ドキュメントの実装が含まれます。これにより、GitLabの認証オプションが強化され、ブラウザを持たないデバイスや入力機能が限られたデバイスでも利用しやすくなりました。


    「共同開発プログラムは、外部コントリビューターとしてGitLabにコントリビュートする最も効率的で効果的な方法です」と、Kitwareの研究開発エンジニアであるJohn
    Parent氏は話します。「デベロッパー同士のペアリングセッションを通じて、1人で作業していたら見逃していたかもしれない、より優れた実装方法を見つけることができました」。


    長年にわたりオープンソースにコントリビュートしてきたKitwareは、GitLabの開発手法を特に高く評価しています。「GitLabほどの規模であれば、既成のソリューションに頼ることはないだろうと思っていましたが、社内で独自のソリューションを開発するのではなく、Rubyの依存関係を取り入れているのを見て、とても興味深かったです」とParent氏は述べます。「C++の世界ではパッケージマネージャーがほとんど使われないため、このようなアプローチを目にし、そのシンプルさを実感できたのは新鮮でした」。


    ## 共に築く未来：共同開発のメリット

    共同開発プログラムは、双方に価値をもたらします。「このプログラムは、GitLabのエンジニアとユーザーの間のギャップを埋める役割を果たしています」と、GitLabのスタッフバックエンドエンジニアであるImre
    Farkasは説明します。「ユーザーと一緒に取り組む中で、日々の課題や、GitLabのどの部分を活用しているのか、どこに改善の余地があるのかを直接聞くことができます。ユーザーがGitLabの開発に積極的に関わろうとしている姿は、とても印象的です」。


    この協力的なアプローチには、GitLabの開発スピードを加速させる効果もあります。GitLabのプリンシパルエンジニアであるShekhar
    Patnaikは次のように述べています。「共同開発を通じて、ユーザーはGitLabのロードマップを前進させる手助けをしてくれています。このコントリビュートによっては重要な機能をより早く提供できるようになり、ユーザーベース全体にとって大きなメリットとなっています。このプログラムが拡大するにつれて、実際にその機能を必要としているユーザーと共に開発を進めることで、最も重要な機能の開発をさらに加速できる可能性があります」。


    ## 共同開発を始める

    機能リクエストを実現しませんか？ThalesのようにGitLabのUIを強化したい、Scaniaのようにパッケージサポートを充実させたい、またはKitwareのように認証機能を改善したいとお考えの方へ。共同開発プログラムでは、価値あるオープンソースの経験を積みながら、GitLabの未来を積極的に形作りたい組織を歓迎します。


    共同開発プログラムへの参加について詳しくは、GitLabの担当者にお問い合わせいただくか、[共同開発のページ](https://about.gitlab.com/community/co-create/)をご覧ください。
  category: お客様事例
  tags:
    - contributors
    - open source
    - customers
config:
  slug: the-co-create-program-how-customers-are-collaborating-to-build-gitlab
  featured: true
  template: BlogPost
